import cherrypy
import rootapp.pages
import kidpages.common.generallist

# import the epl interface
import eplapi
import eplglobals
import string
import wpidn
import sys
import traceback
import kidpages.common.generallist
import vh3.db.bandwidth as bandwidthdb
MAXPIX = 100
svc_name = 'bandwidth'

import kidpages.reseller.services.bandwidth.show_bandwidth
import kidpages.reseller.services.bandwidth.view_site_usage
from lib.datamodel.controls import Column
from lib.datamodel.resellerviews import ResellerListEntryView, SiteBandWidthView

class Page (rootapp.pages.ResellerPage):
    def get_month_dropdownbox1(self,domain,start,end):
        months = {   1 : _("January"),
                     2 : _("February"),
                     3 : _("March"),
                     4 : _("April"),
                     5 : _("May"),
                     6 : _("June"),
                     7 : _("July"),
                     8 : _("August"),
                     9 : _("September"),
                     10: _("October"),
                     11: _("November"),
                     12: _("December")
                 }
        retval,old_rollover,new_rollover = bandwidthdb.collect_all_rollovers(domain)
        if ((not old_rollover) and (not new_rollover)):
            return ([],[],start,end,1)
	redirect_value="view_site_usage?domain=%s"% domain
	#redirect_value="view_site_usage"
        select_dispstring=""
        selectlist=[]
        if ((start!=None) and (end!=None)):	
            (syear,smonth,sday) = string.split(start,"-")
            (eyear,emonth,eday) = string.split(end,"-")
            smonth_name = months[int(smonth)]
            emonth_name = months[int(emonth)]
            select_dispstring="%s %s %s to %s %s %s"%(sday,smonth_name,syear,eday,emonth_name,eyear)
            redirecturl="%s&start=%s&end=%s"%(redirect_value,start,end)
        elif (start!=None):
            (syear,smonth,sday) = string.split(start,"-")
            smonth_name = months[int(smonth)]
            select_dispstring = sday + " " + smonth_name + " " + syear + _(" to Now")
            #select_dispstring="%s %s %s to Now"%(sday,smonth_name,syear)
            redirecturl="%s&start=%s&end=None"%(redirect_value,start)
        else:
            if len(new_rollover)==1:
                start=new_rollover[0][0]
                (syear,smonth,sday) = string.split(start,"-")
                smonth_name = months[int(smonth)] 
                select_dispstring = sday + " " + smonth_name + " " + syear + _(" to Now")
                #select_dispstring="%s %s %s to Now"%(sday,smonth_name,syear)
                redirecturl="%s&start=%s&end=None"%(redirect_value,start)
            else:
                # no current records
                last_val=old_rollover[len(old_rollover)-1]
                old_rollover.remove(last_val) 

                start = last_val[0]
                end = last_val[1]
                (syear,smonth,sday) = string.split(start,"-")
                (eyear,emonth,eday) = string.split(end,"-")
                smonth_name = months[int(smonth)]
                emonth_name = months[int(emonth)]
                select_dispstring="%s %s %s to %s %s %s"%(sday,smonth_name,syear,eday,emonth_name,eyear)
                redirecturl="%s&start=%s&end=%s"%(redirect_value,start,end)
 
        tmp_dict={}
        tmp_dict['name'] = select_dispstring
        tmp_dict['value'] = redirecturl
        selectlist.append(tmp_dict)
 

        droplist=[]
        for eachroll in new_rollover:
            old_rollover.append(eachroll)

        for eachroll in old_rollover:
            if ((len(eachroll)) and (eachroll[0]!=None)):  
                startm=eachroll[0]
                endm=eachroll[1] 
                (syear,smonth,sday) = string.split(startm,"-")
                smonth_name = months[int(smonth)]
                if endm!=None: 
                    (eyear,emonth,eday) = string.split(endm,"-")
                    emonth_name = months[int(emonth)]
                    dispstring="%s %s %s to %s %s %s"%(sday,smonth_name,syear,eday,emonth_name,eyear)
                else:
                    dispstring = sday + " " + smonth_name + " " + syear + _(" to Now")
                    #dispstring="%s %s %s to Now"%(sday,smonth_name,syear)

                if select_dispstring != dispstring: 
                    tmp_dict={}
                    tmp_dict['name'] = dispstring
                    tmp_dict['value'] = "%s&start=%s&end=%s"%(redirect_value,startm,endm)
                    droplist.append(tmp_dict)

        return (droplist,selectlist,start,end,0) 
  
    def view_site_usage(self,domain,start=None,end=None):
        """Initialiase: user obj is set from session obj.
           site obj from user obj
           file obj from site obj
           Then the webppiance is chrooted to user dir"""
        template = self.kidglobals( kidpages.reseller.services.bandwidth.view_site_usage )

	if start == 'None':
		start = None
	if end == 'None':
		end = None

	if domain:
             template.domain = domain
	else:
       	     template.domain = None

	template.oh="oh_reseller_viewing_bandwidth_usage_reports_for_a_specific_site.htm"

	try:
          droplist,selectlist,start,end,data_flag = self.get_month_dropdownbox1(domain,start,end)

	  template.no_data_flag = 0
	  template.no_data_yet = 0
	  template.data_flag = 0
	  template.select_list = 1

	  if data_flag:	
	          template.no_data_flag = 1
	          template.select_list = 0
	  else:	
	          template.data_flag = 1

                  template.selectedlist = selectlist
                  template.unselectedlist = droplist

	          tablehead_display = selectlist[0]['name']
                  if end == None:
                       sql_query = bandwidthdb.current_svc_totals_sql
                       params={'startdate':"%s"%start,'domain':domain}
                  else:
                       sql_query = bandwidthdb.previous_svc_totals_sql
                       params={'startdate':"%s"%start, 'enddate':"%s"%end, 'domain':domain}
          
                  data,maxnum = bandwidthdb.get_bw_site_svc_totals_all(domain,sql_query,params) 
        
                  # get the stats last updated value
                  get_status = bandwidthdb.get_last_updated_status(domain,start,end)
                  get_status=get_status[0][0]
	
	          template.tablehead_display = tablehead_display
                  template.data = data
                  template.maxnum = maxnum
                  template.get_status = get_status

	          if data:
                       for domain,bwthreshold,bwin,bwout,svcdict,begindate,enddate in data:
	   	           bwtotal = bwin + bwout
		           bwavail = bwthreshold - bwtotal
		           svcs = svcdict.keys()
		           svcs.sort()		
                           # pdomain = wpidn.prettyutf8(wpidn.punycode_to_utf8(domain))
                           # template.pdomain = pdomain
                           template.domain = domain
                           template.bwthreshold = self.renderNumInMB(bwthreshold)
                           template.bwtotal = self.renderNumInMB(bwtotal)
                           template.bwout = self.renderNumInMB(bwout)
                           template.bwin = self.renderNumInMB(bwin)
                           template.bwavail = self.renderNumInMB(bwavail)
                           template.bin = bwin
                           template.bout = bwout
                           template.btotal = bwtotal
                           template.bthreshold = bwthreshold
                           template.svcdict = svcdict
                           template.begindate = begindate
                           template.enddate = enddate
                           template.svcs = svcs
                           template.svcdict = svcdict

	          else:
	                   template.no_data_yet = 1
	                   template.data_flag = 0


          return self.kidserialize (template)
        except:
             traceback.print_exc(file=sys.stderr)

    view_site_usage.exposed = True

    def renderNumInMB(self, num):
        num = round(float(num) / 1048576, 3)
        return self.renderNumWithCommas('%s'%num)
 
    def renderNumWithCommas(self,num):
        numlist = string.split(num,'.')
        num = numlist[0][-3:]
        numstring = numlist[0][:-3]
        while (len(numstring) > 0):
           num = numstring[-3:] + ',' + num
           numstring=numstring[:-3]
        if (len(numlist) == 1):
           return num
        else:
           return string.join([num,numlist[1]],'.')


    def show_bandwidth(self,domain=None,bwfunc='get_bw_totals'):
        """Initialiase: user obj is set from session obj.
           site obj from user obj
           file obj from site obj
           Then the webppiance is chrooted to user dir"""
        template = self.kidglobals( kidpages.reseller.services.bandwidth.show_bandwidth )
	if domain:
             template.domain = domain
	else:
       	     template.domain = None

	last = 0
        mydata = []
        config = {}
        allsites = eplapiCurrentUser().sitesInfo()
	template.currentnavactive=""
	template.lastnavactive=""


	if bwfunc == 'get_bw_totals':
		data,maxnum,domcount = bandwidthdb.get_bw_totals(10,0)
		template.oh="oh_reseller_viewing_current_bandwidth_usage_report.htm"
		template.currentnavactive="subnav-link-active"
	else:
		data,maxnum,domcount = bandwidthdb.get_last_bw_totals(10,0)
		template.oh="oh_reseller_viewing_past_bandwidth_usage_report.htm"
		template.lastnavactive="subnav-link-active"
		last = 1

        template.data_flag = 0
        template.no_data_flag = 0

        if data :
          template.data_flag = 1
          for site in allsites:
            config = {}
            bytesperpix = maxnum/MAXPIX
	    for domain, bwin, bwout, bwthreshold in data:
	     if domain == site['domain']:	
              try:
		#pdomain = wpidn.prettyutf8(wpidn.punycode_to_utf8(domain)) 
		bwtotal = bwin+bwout
		bwusedpercent = round(100*float(bwtotal)/float(bwthreshold))

		if bwtotal > bwthreshold:
		  out = bwtotal-bwthreshold

                  config['site'] = domain

                  config['bandwidth'] = "/static/images/dot_gray1.gif"
		  config['bandwidthout'] = "/static/images/dot_red1.gif"
		  config['bwusagein'] = 200
		  config['bwusageout'] = (bwtotal - bwthreshold)/bwthreshold*200

                  config['used'] = self.renderNumInMB(bwtotal)
                  config['threshold'] = self.renderNumInMB(bwthreshold)
                  config['difference'] = self.renderNumInMB(bwtotal - bwthreshold)
                  config['perused'] = bwusedpercent

            	  mydata.append(config)

		else :
		  out = bwthreshold-bwtotal

                  config['site'] = domain

                  config['bandwidth'] = "/static/images/dot_gray1.gif"
		  config['bandwidthout'] = "/static/images/dot_green1.gif"
		  config['bwusagein'] = (bwtotal/bwthreshold)*200
		  config['bwusageout'] = (bwthreshold - bwtotal)/bwthreshold*200

                  config['used'] = self.renderNumInMB(bwtotal)
                  config['threshold'] = self.renderNumInMB(bwthreshold)
                  config['difference'] = self.renderNumInMB(bwthreshold - bwtotal)
                  config['perused'] = bwusedpercent

            	  mydata.append(config)

	      except ZeroDivisionError:
		  out = bwtotal-bwthreshold

                  config['site'] = domain

                  config['bandwidth'] = "/static/images/dot_green1.gif"
		  config['bandwidthout'] = "/static/images/dot_green1.gif"
		  config['bwusagein'] = 0
		  config['bwusageout'] = 0

                  config['used'] = self.renderNumInMB(bwtotal)
                  config['threshold'] = _("Unlimited")
                  config['difference'] = "N.A."
                  config['perused'] = "N.A."

            	  mydata.append(config)
        else:
        	template.no_data_flag = 1
        # provide mydata to the generallist kid page.
        column_list = [
                  Column (name = 'site',  title = _('Site'),  searchable=True, sortable=True),
                  Column (name = 'bandwidth',   title = _('Bandwidth'), sortable=True),
                  Column (name = 'used',     title = _('Used (M)')),
                  Column (name = 'threshold',     title = _('Threshold (M)')),
                  Column (name = 'difference',     title = _('Difference (M)')),
                  Column (name = 'perused',     title = _('% Used'))
              ]
	if last:
	    template.page_title = _('Last Usage Reports')
	    template.list_title = _('Last Usage Reports')
	else:
	    template.page_title = _('Current Usage Reports')
	    template.list_title = _('Current Usage Reports')

        template.column_list = column_list
        template.display_data = mydata
        template.entryview = SiteBandWidthView
        template.display_view = "SITELIST"


        return self.kidserialize (template)

    show_bandwidth.exposed = True
