# Apache ISP Views Classes should be coded here.
import lib.datamodel.datatypes
from lib.common.convertunits import convert_to_MB
class LogFilesListEntryView( lib.datamodel.datatypes.EntryView ):

    def view_actions( self, entry ):
        return "<a href='/isp/services/apache/downloadLogFile?logfile=%s'>%s</a>"%(entry['location'],_('Download'))

    def view_size( self, entry ):
        return convert_to_MB(entry['size'],'M')
